clc;


%Joint Distribution for Wind and Waves

%Parameter for Mean Peak Period
c1=4.883;
c2=2.68;
c3=0.529;

%Parameter for Mean Wind Speed
d1=1.764;
d2=3.426;
d3=0.78;

%Paramter for Peak Period
theta=-0.19;
gamma=1;

%Paramter for Wind Density
alfaw=1.708;
betaw=8.426;

for w = 1:1:24
for h = 1:1:20;
        for t = 1:1:20

%Paramter for Hm0 given wind		
alfah=2+0.135*w;
betah=1.8 + 0.1*w^1.322;

ET(h)=c1+c2*h^c3;
EW(h)=d1+d2*h^d3;

T(h)=ET(h)*(1+theta*(((w-EW(h))/EW(h))));

sigmaTp(h)=(-0.0017+0.259*exp(-0.113*h))*T(h);

vyTp(h)=sigmaTp(h)/T(h);

mylnTp(h)=log(T(h)/(sqrt(1+vyTp(h)^2)));

sigmalnTp(h)=sqrt(log(vyTp(h)^2+1));

fTp(t,h)=(1/(t*sigmalnTp(h)*sqrt(2*pi)))*exp(-0.5*((log(t)-mylnTp(h))/(sigmalnTp(h)))^2);

fw=(alfaw/betaw)*(w/betaw)^(alfaw-1)*exp(-(w/betaw)^alfaw);

fh(h)=(alfah/betah)*(h/betah)^(alfah-1)*exp(-(h/betah)^alfah);

JDensFunc(t,h)=fw*fh(h)*fTp(t,h); %Joint Distribution with constant wind       

fff(w,t,h)=JDensFunc(t,h);  % Total Joint distribution

     end
end
end

%Marginal Probability of Each Load Case
for i = 1:1:16
    for k = 1:1:15
    ProbTp(i,k)=fff(4,i,k);
    end
end
for j= 1:1:15
  for  l = 8:1:10
    ProbHm0(j,l)=fff(4,l,j);
end
end

