import sys
import os,string,shutil
##import pylab as p
import numpy as n
sys.path.append('F:\\Analyser')
from mik_funcs import mik_replace_strings
## June 2011 Inge Moy
##
############## INPUT #########################
## Wind, wave height and wave period vectors
w_hub = n.array([4.,4.,4.,4.,4.,4.,4.,4.,4.,4.,4.,4.,4.,4.,4.]) # Wsp [m/s] at hub
h = n.array([1.,2.,3.,4.,5.,6.,7.,8.,9.,10.,11.,12.,13.,14.,15.]) # Hs [m]
t = n.array([9.,9.,9.,9,9.,9.,9.,9.,9.,9.,9.,9.,9.,9.,9.]) # Tp [s]
theta = n.array([0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]) # wave dir (deg)
p = n.array([0.0056,0.0082,0.0071,0.0061,0.005,0.0031,0.0019,0.001,0.00064147,0.00033391,0.000154240,0.000079099,0.,0.,0.])# Probability density limit # Probability density limit
t_max = 2000.0  # Simulation time, include transient
dt = 0.0125 # time step
## Wind simulation parameters
#~ Nf = 6000  # number of harmonic components
z_hub = 100.0
#~ dz = 0.5
#~ R = 63.0  # Radius rotor
#~ I_ref=0.15  # Turbulence intentsity given by table 1 in IEC61400-1 (turbulence characteristics?)
Lambdai=42.0  #if z>60 m
fmin = 0.0 # minimum freq included in wind sim [Hz]
fmax = 3.0 # max freq
iseed = 1313.0 # Seed for wind and wave, wind and waves are intependent
#~ sigma1h = 0.2  # 0.0 if 10 min stationarity
maindir = 'F:\\Analyser\\WaveHeight_%d' %t_max+'s_seed%d' %iseed +'\\' # Main directory
winddir = 'F:\\Analyser\\Wind\\' # Directory for wind time series
tempdir = 'F:\\Analyser\\Templates\\' # Templates directory
##
prefix = 'Analysis'
infile1 = prefix+'_inpmod.inp.mal'
outfile1 = prefix+'_inpmod.inp'
infile2 = prefix+'_dynmod.inp.mal'
outfile2 = prefix+'_dynmod.inp'
infile3 = 'sys-'+prefix+'.dat.mal'
outfile3 = 'sys-'+prefix+'.dat'
infile4 = prefix+'_stamod.inp'
infile5 = 'tdh3d_nrel5mwwt.inp.mal'
outfile5 = 'tdh3d_nrel5mwwt.inp'
infile6 = 'vind_nrel5mwwt.dat.mal'
outfile6 = 'vind_nrel5mwwt.dat'
infile7 = 'DYN.MAC.mal'
outfile7 = 'DYN.MAC'
############### END INPUT #####################
if not os.path.isdir(maindir):
        os.mkdir(maindir)
#
#~ os.mkdir(maindir)
os.chdir(maindir)
## Find wind at 10 m
#~ w_hub = w10*(z_hub/10.0)**0.14
w10= w_hub*(10.0/z_hub)**0.14
## Finds list of [W(10) Hs Tp p] with probability above plim
Nlc = len(w_hub)
LC_list = []
for i in range(Nlc):
	LC_list.append([w10[i],h[i],t[i],p[i],theta[i]])

f=open('load_cases.txt','w')
f.write('Load Case     Wsp10    Hs     Tp        Prob   Wavedir \n')

## Make directories and generate input files for each load combination
for i in range(Nlc):
	dirname = 'LC%d' %(i+0)
	if not os.path.isdir(maindir+dirname):
		os.mkdir(maindir+dirname)
	os.chdir(maindir+dirname)
	thisdir = os.path.abspath('.')
	lc = LC_list[i]
	f.write('%10s' %dirname + '%7.1f%7.1f%7.1f%12.6f%7.1f' %tuple(lc) +'\n')
	wi10 = lc[0]
	hi = lc[1]
	ti = lc[2]
	pi = lc[3]
	thetai = lc[4]
	## Find pairs of w10 and whub
	for j in range(len(w10)):
		if w10[j] == wi10:
			wihub = w_hub[j]

	if wihub <= 3.0:
		infile3 = 'sys-'+prefix+'2.dat.mal'

##	if i == (Nlc-1) or i == (Nlc-2):
	shutil.copy(tempdir + infile1, thisdir)
	shutil.copy(tempdir + infile2, thisdir)
	shutil.copy(tempdir + infile3, thisdir)
	shutil.copy(tempdir + infile4, thisdir)
	shutil.copy(tempdir + infile5, thisdir)
	shutil.copy(tempdir + infile6, thisdir)
	shutil.copy(tempdir + infile7, thisdir)
	shutil.copy(tempdir + 'STA.MAC', thisdir)
	shutil.copy(tempdir + 'TDHMILL3D_main.DLL', thisdir)
##	shutil.copy(tempdir + 'S2X.MAC', thisdir)

	if wihub<11.4:
		rpm = (12.1-6.9)/(11.4-3.0)*(wihub-3.0)+6.9
		notch = 0.0
	else:
		rpm = 12.1
		notch = 1.0

	I_v = 0.103+0.8/wihub #Turbulence intensity as function of wsp IEC61400-1

##	if i == (Nlc-1) or i == (Nlc-2):
        # Replace strings in mal-files and make new input files
        ## Inpmod
	oldstrings1 = ['>>sigwahe','>>tp','>>wadir']
	newstrings1 = [hi,ti,thetai]
	format1 = ['%9.1f','%9.1f','%9.0f']
	mik_replace_strings(infile1,outfile1,oldstrings1,newstrings1,format1)

        ## Dynmod
	oldstrings2 = ['>>iseed','>>time','>>dt']
	newstrings2 = [iseed,t_max,dt]
	format2 = ['%4d','%8d','%5.5f','%5.2f']
	mik_replace_strings(infile2,outfile2,oldstrings2,newstrings2,format2)

        ## Sys
	oldstrings3 = ['>>siwahe','>>tpeak','>>wadir','>>wsp']
	newstrings3 = [hi,ti,thetai,wi10]
	format3 = ['%9.1f','%9.1f','%7.0f','%7.1f'] #
	mik_replace_strings(infile3,outfile3,oldstrings3,newstrings3,format3)

        ## Turbin
	oldstrings5 = ['>>rpm','>>notch','>>dt']
	newstrings5 = [rpm,notch,dt]
	format5 = ['%5.1f','%3i','%5.5f'] #
	mik_replace_strings(infile5,outfile5,oldstrings5,newstrings5,format5)

        ## Vind
	oldstrings6 = ['>>umean','>>turb','>>lambda','>>tslen','>>fmin','>>fmax','>>iseed']
	newstrings6 = [wihub,I_v,Lambdai,t_max,fmin,fmax,iseed]
	format6 = ['%7.1f','%7.2f','%7.1f','%7.1f','%6.1f','%6.1f','%6d'] #
	mik_replace_strings(infile6,outfile6,oldstrings6,newstrings6,format6)

        ## dyn.mac
	oldstrings7 = ['>>iseed']
	newstrings7 = [iseed]
	format7 = ['%d'] #
	mik_replace_strings(infile7,outfile7,oldstrings7,newstrings7,format7)

	os.remove(infile1)
	os.remove(infile2)
	os.remove(infile3)
	os.remove(infile5)
	os.remove(infile6)
	os.remove(infile7)

	os.chdir(maindir)

f.close()







